/*-----------------------------------------------------------------------------
	Paper Plane xUI Common Control eXtension Module				(c)TORO
-----------------------------------------------------------------------------*/
#define STRICT
#include <windows.h>
#include "ppx.h"
#include "vfs.h"
#include "PPX_DRAW.h"
#undef EXTDLL
#define EXTDLL

#define RELEASEVERSION L"T1"

int TipX(PPXAPPINFOW *ppxa, PPXMCOMMANDSTRUCT *command);
int InitExtComplist(PPXAPPINFOW *ppxa, PPXMEXTLISTBOX *els);

#define TIPMARGINWIDTH 2
#define TIPBORDERWIDTH 1
#define TIPTEXTLENGTH 0x400
#define TIP_DRAW_FLAGS (DT_LEFT | DT_NOPREFIX | DT_WORDBREAK | DT_EDITCONTROL | DT_EXPANDTABS)

extern UINT WM_PPXCOMMAND;
UINT WM_PPXCOMMAND;

void FillBox(HDC hDC, const RECT *box, HBRUSH hbr)
{
	HGDIOBJ hOldObj;

	hOldObj = SelectObject(hDC, hbr);
	PatBlt(hDC, box->left, box->top, box->right - box->left, box->bottom - box->top, PATCOPY);
	SelectObject(hDC, hOldObj);
}
UTCHAR GetCommandParameter(LPCTSTR *commandline, TCHAR *param, size_t paramlen)
{
	const TCHAR *src;
	TCHAR *dest, *destmax;
	UTCHAR firstcode, code;

	firstcode = SkipSpace(commandline);
	if ( (firstcode == '\0') || (firstcode == ',') ){ // p[^
		*param = '\0';
		return firstcode;
	}
	dest = param;
	destmax = dest + paramlen - 1;
	if ( firstcode == '\"' ){
		GetQuotedParameter(commandline, param, destmax);
		return *param;
	}
	src = *commandline + 1;
	code = firstcode;
	for ( ;; ){
		if ( dest < destmax ) *dest++ = code;
		code = *src;
		if ( (code == ',') || // (code == ' ') ||
			 ((code < ' ') && ((code == '\0') || (code == '\t') ||
							   (code == '\r') || (code == '\n'))) ){
			break;
		}
		src++;
	}
	while ( (dest > param) && (*(dest - 1) == ' ') ) dest--; // choptail
	*dest = '\0';
	*commandline = src;
	return firstcode;
}

HINSTANCE hInst;
const WCHAR NilStr[] = L"";
THEME_COLORS WinColors;
#define C_DialogBack (WinColors.c.DialogBack) // _CAO\(3dFace)
#define C_FocusBack (WinColors.c.FocusBack)
#define C_DialogText (WinColors.c.DialogText) // _CAO

/*-----------------------------------------------------------------------------
	dll ̏^I
-----------------------------------------------------------------------------*/
#pragma argsused
BOOL WINAPI DllEntry(HINSTANCE hInstance, DWORD reason, LPVOID reserved)
{
	if ( reason == DLL_PROCESS_ATTACH ){
		hInst = hInstance;
	}
	return TRUE;
}

/*-----------------------------------------------------------------------------
	{
-----------------------------------------------------------------------------*/
#pragma argsused
int PPXAPI ModuleEntry(PPXAPPINFOW *ppxa, DWORD cmdID, PPXMODULEPARAM pxs)
{
	if ( cmdID == PPXMEVENT_COMMAND ){
		if ( /*(pxs.command->commandhash == 0xc5555e55) &&*/ !wcscmp(pxs.command->commandname, L"TIPX") ){
			return TipX(ppxa, pxs.command);
		}
	} else if ( cmdID == PPXMEVENT_EXLISTBOX ){
		return InitExtComplist(ppxa, pxs.listbox);
	} else if ( cmdID == PPXM_INFORMATION ){
		if ( pxs.info->infotype == 0 ){
			pxs.info->typeflags = PPMTYPEFLAGS(PPXM_INFORMATION) |
				PPMTYPEFLAGS(PPXMEVENT_EXLISTBOX);
			wcscpy(pxs.info->copyright, L"PPx CCX Module " RELEASEVERSION L"  Copyright (c)TORO");
			return PPXMRESULT_DONE;
		}
	}
	return PPXMRESULT_SKIP;
}



COLORREF C_tip[2] = {C_AUTO, C_AUTO};
int X_uxt[2] = {X_uxt_defvalue};
const WCHAR FileTipClass[] = L"XTip";


LRESULT CALLBACK TipWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	DXDRAWSTRUCT *DxDraw;

	switch ( message ){
		case WM_CREATE:
			CreateDxDraw(&DxDraw, hWnd);
			SetWindowLongPtr(hWnd, 0, (LONG_PTR)DxDraw);
			return 0;

		case WM_DESTROY:
			DxDraw = (DXDRAWSTRUCT *)GetWindowLongPtr(hWnd, 0);
			CloseDxDraw(&DxDraw);
			return 0;

		case WM_DISPLAYCHANGE:
			InvalidateRect(hWnd, NULL, TRUE);
			// WM_SIZE 
		case WM_SIZE:
			DxDraw = (DXDRAWSTRUCT *)GetWindowLongPtr(hWnd, 0);
			ChangeSizeDxDraw(DxDraw, C_tip[1]);
			return DefWindowProc(hWnd, message, wParam, lParam);

		case WM_PAINT: {
			TCHAR textbuf[TIPTEXTLENGTH], *textptr = textbuf;
			int textlength;
			RECT box;
			HBRUSH hBackBrush;
			PAINTSTRUCT ps;

			textlength = GetWindowTextLength(hWnd) + 1;
			if ( textlength <= 1 ){
				BeginPaint(hWnd, &ps);
				EndPaint(hWnd, &ps);
				return 0;
			}
			if ( textlength >= TIPTEXTLENGTH ){
				textptr = HeapAlloc(GetProcessHeap(), 0, textlength * sizeof(WCHAR));
				if ( textptr == NULL ){
					textptr = textbuf;
					textlength = TIPTEXTLENGTH - 1;
				}
			}
			GetWindowText(hWnd, textptr, textlength);

			DxDraw = (DXDRAWSTRUCT *)GetWindowLongPtr(hWnd, 0);
			GetClientRect(hWnd, &box);
			box.left += TIPMARGINWIDTH;
			box.top += TIPMARGINWIDTH;

			if ( DxDraw == NULL ) BeginPaint(hWnd, &ps);
			if ( BeginDxDraw(DxDraw, &ps) == DXSTART_NODRAW ) return 0;
			IfDXmode(ps.hdc)
			{
				DxSetTextColor(DxDraw, ps.hdc, C_tip[0]);
				DxSetBkColor(DxDraw, ps.hdc, C_tip[1]);
				DxMoveToEx(DxDraw, ps.hdc, box.left, box.top);
				DxDrawText(DxDraw, ps.hdc, textptr, -1, &box, DT_NOCLIP | TIP_DRAW_FLAGS);
				EndDxDraw(DxDraw);
			} else{
				HGDIOBJ hOldFont;

				hOldFont = SelectObject(ps.hdc, /*cinfo->hBoxFont*/ NULL);
				hBackBrush = CreateSolidBrush(C_tip[1]);
				FillBox(ps.hdc, &ps.rcPaint, hBackBrush);
				DeleteObject(hBackBrush);

				SetTextColor(ps.hdc, C_tip[0]);
				SetBkColor(ps.hdc, C_tip[1]);
				DrawText(ps.hdc, textptr, -1, &box, DT_NOCLIP | TIP_DRAW_FLAGS);
				SelectObject(ps.hdc, hOldFont);
				EndPaint(hWnd, &ps);
			}
			if ( textptr != textbuf ) HeapFree(GetProcessHeap(), 0, textptr);
			return 0;
		}
/*
		default:
			if ( message == WM_PPXCOMMAND ){
				return WmTipPPXCOMMAND(hWnd, wParam, lParam);
			}
			break;
*/
	}
	return DefWindowProc(hWnd, message, wParam, lParam);
}


int TipX(PPXAPPINFOW *ppxa, PPXMCOMMANDSTRUCT *command)
{
	const WCHAR *text;
	UINT codepage = VTYPE_UNICODE;
	WNDCLASS wndClass;
	DWORD StyleEx = WS_EX_TOOLWINDOW;
	DWORD Style = WS_POPUP | WS_BORDER | WS_CLIPCHILDREN;
	HWND hTipWnd;

	if ( command->paramcount <= 1 ){
		text = L"sample text";
	}else{
		text = command->param;
	}

	wndClass.style = CS_DBLCLKS;
	wndClass.lpfnWndProc = TipWndProc;
	wndClass.cbClsExtra = 0;
	wndClass.cbWndExtra = sizeof(LONG_PTR);
	wndClass.hInstance = hInst;
	wndClass.hIcon = NULL;
	wndClass.hCursor = LoadCursor(NULL, IDC_ARROW);
	wndClass.hbrBackground = NULL;
	wndClass.lpszMenuName = NULL;
	wndClass.lpszClassName = FileTipClass;
	RegisterClass(&wndClass);

	if ( C_tip[0] == C_AUTO ){
		GetCustData(T("C_tip"), &C_tip, sizeof(C_tip));
		if ( C_tip[0] == C_AUTO ) C_tip[0] = (X_uxt[0] >= UXT_MINPRESET) ? C_DialogText : GetSysColor(COLOR_INFOTEXT);
		if ( C_tip[1] == C_AUTO ) C_tip[1] = (X_uxt[0] >= UXT_MINPRESET) ? C_DialogBack : GetSysColor(COLOR_INFOBK);
	}

	setflag(Style, WS_THICKFRAME);
	hTipWnd = CreateWindowEx(StyleEx, FileTipClass, text,
		Style, 0, 0, 100, 100, ppxa->hWnd,
		NULL, hInst, ppxa);
	ShowWindow(hTipWnd, SW_SHOW);

	return PPXMRESULT_DONE;
}

const WCHAR StrExtComplistProperty[] = L"PxmExtList";

typedef struct {
	DXDRAWSTRUCT *DxDraw;
	WNDPROC OldProc; // ̃EBhEv[W
//	WNDPROC ListProc; // XgRg[̃EBhEv[W
	HFONT hBoxFont;
	HWND ListWnd;
	HWND MsgWnd;
	HWND ParentWnd;
	int ItemHeight;
	int ItemLineSpace;
	int type;
	UINT ListID;
	int fontY;
} ExtCompStruct;

int compinit = 0;

C_WIN_COLORS wincolors = {
	C_AUTO, C_AUTO, C_AUTO, C_AUTO,
	C_AUTO, C_AUTO, C_AUTO, C_AUTO,
	C_AUTO, C_AUTO, C_AUTO, C_AUTO
};
#define C_WindowBack wincolors.WindowBack
#define C_WindowText wincolors.WindowText
#define C_HighlightBack wincolors.HighlightBack
#define C_HighlightText wincolors.HighlightText
#define C_EdgeLine wincolors.EdgeLine

COLORREF C_CommentBack;
COLORREF C_CommentText;

void SetItemHeight(ExtCompStruct *ECS, HFONT hFont)
{
	HDC hDC;
	HGDIOBJ hOldFont C4701CHECK;	//ꎞۑp
	TEXTMETRIC tm;

	hDC = GetWindowDC(ECS->ListWnd);
	if ( hFont ) hOldFont = SelectObject(hDC, hFont);
	GetTextMetrics(hDC, &tm);
	if ( hFont ) SelectObject(hDC, hOldFont); // C4701ok
	ReleaseDC(ECS->ListWnd, hDC);

//	ECS->fontX = tm.tmAveCharWidth;
	ECS->fontY = tm.tmHeight;
	ECS->ItemHeight = ECS->fontY + ECS->ItemLineSpace;

	if ( ECS->ItemLineSpace ){
		SendMessage(ECS->ListWnd, LB_SETITEMHEIGHT, 0, ECS->ItemHeight);
	}
}

LRESULT CALLBACK ExtComplistProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	ExtCompStruct *ECS;

	ECS = GetProp(hWnd, StrExtComplistProperty);
	if ( ECS == NULL ) return DefWindowProc(hWnd, message, wParam, lParam);

	switch ( message ){
		case WM_SETFONT: {
			LRESULT result = CallWindowProc(ECS->OldProc, hWnd, message, wParam, lParam);
			SetItemHeight(ECS, (HFONT)wParam);
			return result;
		}

		case WM_DESTROY:
			RemoveProp(hWnd, StrExtComplistProperty);
//			CloseDxDraw(&ECS->DxDraw);
			HeapFree(GetProcessHeap(), 0, ECS);
			break;
#if 0
		case WM_DISPLAYCHANGE:
			InvalidateRect(hWnd, NULL, TRUE);
			// WM_SIZE 
		case WM_SIZE:
			ChangeSizeDxDraw(ECS->DxDraw, C_tip[1]);
			break;

		case WM_PAINT: {
			TCHAR textbuf[TIPTEXTLENGTH], *textptr = textbuf;
			int textlength;
			RECT box;
			HBRUSH hBackBrush;
			PAINTSTRUCT ps;
			DXDRAWSTRUCT *DxDraw;

			//textlength = GetWindowTextLength(hWnd) + 1;
			textlength = 5;

			if ( textlength <= 1 ){
				BeginPaint(hWnd, &ps);
				EndPaint(hWnd, &ps);
				return 0;
			}
			if ( textlength >= TIPTEXTLENGTH ){
				textptr = HeapAlloc(GetProcessHeap(), 0, textlength * sizeof(WCHAR));
				if ( textptr == NULL ){
					textptr = textbuf;
					textlength = TIPTEXTLENGTH - 1;
				}
			}
			GetWindowText(hWnd, textptr, textlength);

			DxDraw = ECS->DxDraw;
			GetClientRect(hWnd, &box);
			box.left += TIPMARGINWIDTH;
			box.top += TIPMARGINWIDTH;

			if ( DxDraw == NULL ) BeginPaint(hWnd, &ps);
			if ( BeginDxDraw(DxDraw, &ps) == DXSTART_NODRAW ) return 0;
			IfDXmode(ps.hdc)
			{
				DxSetTextColor(DxDraw, ps.hdc, C_tip[0]);
				DxSetBkColor(DxDraw, ps.hdc, C_tip[1]);
				DxMoveToEx(DxDraw, ps.hdc, box.left, box.top);
				DxDrawText(DxDraw, ps.hdc, textptr, -1, &box, DT_NOCLIP | TIP_DRAW_FLAGS);
				EndDxDraw(DxDraw);
			} else{
				HGDIOBJ hOldFont;

				hOldFont = SelectObject(ps.hdc, ECS->hBoxFont);
				hBackBrush = CreateSolidBrush(C_tip[1]);
				FillBox(ps.hdc, &ps.rcPaint, hBackBrush);
				DeleteObject(hBackBrush);

				SetTextColor(ps.hdc, C_tip[0]);
				SetBkColor(ps.hdc, C_tip[1]);
				DrawText(ps.hdc, textptr, -1, &box, DT_NOCLIP | TIP_DRAW_FLAGS);
				SelectObject(ps.hdc, hOldFont);
				EndPaint(hWnd, &ps);
			}
			if ( textptr != textbuf ) HeapFree(GetProcessHeap(), 0, textptr);
			return 0;
		}
#endif
/*
		default:
			if ( message == WM_PPXCOMMAND ){
				return WmTipPPXCOMMAND(hWnd, wParam, lParam);
			}
			break;
*/
	}
	return CallWindowProc(ECS->OldProc, hWnd, message, wParam, lParam);
}

void CompDraw(ExtCompStruct *ECS, DRAWITEMSTRUCT *lpdis)
{
	TCHAR buf[CMDLINESIZE], *bufp = buf, *mem = NULL;
	int len;

	if ( (int)lpdis->itemID >= 0 ){
		HBRUSH hB;
		COLORREF OldText, OldBack;
		COLORREF OldText2, OldBack2;
		int OldBkMode;
		RECT box;
		TCHAR *memostart;

		box = lpdis->rcItem;

		if ( lpdis->itemState & ODS_SELECTED ){
			OldText = SetTextColor(lpdis->hDC, C_HighlightText);
			OldBack = SetBkColor(lpdis->hDC, C_HighlightBack);

			hB = CreateSolidBrush(C_HighlightBack);
			FillRect(lpdis->hDC, &lpdis->rcItem, hB);
			DeleteObject(hB);
		}else{
			hB = CreateSolidBrush(C_WindowBack);
			FillRect(lpdis->hDC, &lpdis->rcItem, hB);
			DeleteObject(hB);
		}

		box.top += ECS->ItemLineSpace / 2;

		// \`
		len = SendMessage(lpdis->hwndItem, LB_GETTEXTLEN, lpdis->itemID, 0);
		if ( len >= (CMDLINESIZE - 1) ){
			bufp = mem = HeapAlloc(GetProcessHeap(), 0, len * sizeof(WCHAR));
		}
		SendMessage(lpdis->hwndItem, LB_GETTEXT, lpdis->itemID, (LPARAM)bufp);

		if ( (bufp[0] == ';') && (bufp[1] == '<') ){
			WCHAR *comout;
			POINT pos;

			comout = wcsstr(bufp + 2, L">;");
			if ( comout != NULL ){
				SetTextAlign(lpdis->hDC, TA_LEFT | TA_TOP | TA_UPDATECP); // CP L
				OldBkMode = SetBkMode(lpdis->hDC, OPAQUE);
				OldText2 = SetTextColor(lpdis->hDC, C_CommentText);
				if ( lpdis->itemState & ODS_SELECTED ){
					OldBack2 = SetBkColor(lpdis->hDC, C_HighlightBack);
				}else{
					OldBack2 = SetBkColor(lpdis->hDC, C_CommentBack);
				}

				MoveToEx(lpdis->hDC, box.left, box.top, NULL);
				DrawText(lpdis->hDC, bufp + 2, comout - bufp - 2, &box, DT_END_ELLIPSIS | DT_NOPREFIX);

				GetCurrentPositionEx(lpdis->hDC, &pos);
				box.left = pos.x;
				box.top = pos.y;
				len -= comout - bufp - 2;
				bufp = comout + 2;

				SetTextColor(lpdis->hDC, OldText2);
				SetBkColor(lpdis->hDC, OldBack2);

				SetBkMode(lpdis->hDC, OldBkMode);
				SetTextAlign(lpdis->hDC, TA_LEFT | TA_TOP);
			}
		}
				// Rgȍ~𕪗
		for( memostart = bufp;; memostart++ ){
			TCHAR c;

			c = *memostart;
			if ( c == '\0' ){
				DrawText(lpdis->hDC, bufp, len, &box, DT_END_ELLIPSIS | DT_NOPREFIX);
				break;
			}
			if ( (c == ' ') || (c == '\t') ){
				if ( *(memostart + 1) == ';' ){
					SetTextAlign(lpdis->hDC, TA_LEFT | TA_TOP | TA_UPDATECP); // CP L
				OldBkMode = SetBkMode(lpdis->hDC, OPAQUE);
					MoveToEx(lpdis->hDC, box.left, box.top, NULL);
					DrawText(lpdis->hDC, bufp, memostart - bufp, &box, DT_END_ELLIPSIS | DT_NOPREFIX);
					OldText2 = SetTextColor(lpdis->hDC, C_CommentText);
					if ( lpdis->itemState & ODS_SELECTED ){
						OldBack2 = SetBkColor(lpdis->hDC, C_HighlightBack);
					}else{
						OldBack2 = SetBkColor(lpdis->hDC, C_CommentBack);
					}
					DrawText(lpdis->hDC, memostart, len - (memostart - bufp), &box, DT_END_ELLIPSIS | DT_NOPREFIX);
					SetTextColor(lpdis->hDC, OldText2);
					SetBkColor(lpdis->hDC, OldBack2);
				SetBkMode(lpdis->hDC, OldBkMode);
				SetTextAlign(lpdis->hDC, TA_LEFT | TA_TOP);
					break;
				}
			}
		}

		if ( mem != NULL ) HeapFree(GetProcessHeap(), 0, mem);

		if ( lpdis->itemState & ODS_SELECTED ){
			SetTextColor(lpdis->hDC, OldText);
			SetBkColor(lpdis->hDC, OldBack);
		}
	}

	// tH[JXg`
	if ( lpdis->itemState & ODS_FOCUS ){
		// C_EdgeLine
		FrameRect(lpdis->hDC, &lpdis->rcItem, GetStockObject(DKGRAY_BRUSH));
	}
}

LRESULT CALLBACK CompMsgProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	ExtCompStruct *ECS;

	ECS = (ExtCompStruct *)GetWindowLongPtr(hWnd, GWLP_USERDATA);
	if ( ECS == NULL ){
		if ( message == WM_CREATE ){
			SetWindowLongPtr(hWnd, GWLP_USERDATA,
					(LONG_PTR)(((CREATESTRUCT *)lParam)->lpCreateParams));
			return 0;
		}
		// WM_CREATE ̑O WM_GETMINMAXINFO, WM_NCCREATE, WM_NCDESTROY,
		// WM_NCCALCSIZE 
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	switch ( message ){
/*
		case WM_MEASUREITEM:
				((MEASUREITEMSTRUCT *)lParam)->itemHeight =
						InitDrawHeight(GetDlgItem(hDlg, wParam));
			return TRUE;
*/
		case WM_DRAWITEM:
			CompDraw(ECS, (DRAWITEMSTRUCT *)lParam);
			return 0;

		case WM_COMMAND:
			return SendMessage(ECS->ParentWnd, WM_COMMAND, wParam, lParam);
	}
	return DefWindowProc(hWnd, message, wParam, lParam);
}

#define CompMsgClass L"CompMsgClass"
ATOM CompMsgAtom = 0;

#define DEFWINCOLOR(Color, Type) if ( Color == C_AUTO ) Color = GetSysColor(Type);

int InitExtComplist(PPXAPPINFOW *ppxa, PPXMEXTLISTBOX *els)
{
	ExtCompStruct *ECS;
	WCHAR buf[CMDLINESIZE];
	const WCHAR *bufp;

	if ( compinit == 0 ){
		if ( CompMsgAtom == 0 ){
			WNDCLASS wcClass;

			wcClass.style			= 0;
			wcClass.lpfnWndProc		= CompMsgProc;
			wcClass.cbClsExtra		= 0;
			wcClass.cbWndExtra		= 0;
			wcClass.hInstance		= hInst;
			wcClass.hIcon			= NULL;
			wcClass.hCursor			= NULL;
			wcClass.hbrBackground	= NULL;
			wcClass.lpszMenuName	= NULL;
			wcClass.lpszClassName	= CompMsgClass;
											// NXo^
			CompMsgAtom = RegisterClass(&wcClass);
		}

		GetCustData(L"C_win", &wincolors, sizeof(wincolors));

		DEFWINCOLOR(C_WindowBack, COLOR_WINDOW);
		DEFWINCOLOR(C_WindowText, COLOR_WINDOWTEXT);
		DEFWINCOLOR(C_HighlightText, COLOR_HIGHLIGHTTEXT);
		DEFWINCOLOR(C_HighlightBack, COLOR_HIGHLIGHT);
		DEFWINCOLOR(C_EdgeLine, COLOR_LIGHT_EDGE_LINE);

		C_CommentBack = C_WindowBack;
		C_CommentText = 0x0080FF;

		buf[0] = '\0';
		GetCustTable(L"_others", L"ListCommentColor", &buf, sizeof(buf));
		bufp = buf;
		if ( *bufp != '\0' ){
			C_CommentText = GetColor(&bufp, TRUE);
			if ( SkipSpace(&bufp) == ',' ){
				bufp++;
				C_CommentBack = GetColor(&bufp, TRUE);
			}
		}
		compinit = 1;
	}

	ECS = HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, sizeof(ExtCompStruct));

	ECS->ParentWnd = els->hParentWnd;
	ECS->MsgWnd = CreateWindowEx(0, (const TCHAR *)CompMsgAtom, NilStr, 0,
			0, 0, 1, 1,
			ECS->ParentWnd, NULL, hInst, ECS);
	ECS->ListID = (UINT)els->hMenu;

	ECS->ListWnd = els->hListWnd = CreateWindowEx(els->ExStyle, L"LISTBOX",
			NilStr, els->Style | LBS_HASSTRINGS | LBS_OWNERDRAWFIXED,
			els->x, els->y, els->width, els->height,
			ECS->MsgWnd, els->hMenu, els->hInst, els->lParam);
	// CreateDxDraw(&ECS->DxDraw, hListWnd);

	SetProp(els->hListWnd, StrExtComplistProperty, (HANDLE)ECS);
	ECS->OldProc = (WNDPROC)SetWindowLongPtr(els->hListWnd, GWLP_WNDPROC, (LONG_PTR)ExtComplistProc);

	buf[0] = '\0';
	GetCustTable(L"_others", L"ListItemSpace", &buf, sizeof(buf));
	bufp = buf;
	if ( *bufp != '\0' ) ECS->ItemLineSpace = GetNumber(&bufp);

	{
		HFONT ListFont = (HFONT)SendMessage(els->hParentWnd, WM_GETFONT, 0, 0);

		SendMessage(ECS->ListWnd, WM_SETFONT, (WPARAM)ListFont, 0);
		SetItemHeight(ECS, ListFont);
	}
	ECS->type = els->type;
	return PPXMRESULT_DONE;
}
